HDU 1010 Tempter of the Bone dfs+剪枝

给你一个迷宫一个起点和一个终点,问你能否走T步刚好到达终点,不能重复走,并且只有4个方向

显然这是一个dfs,虽然N最大只有7,但是裸的dfs复杂度还是太高了,因此要进行一些剪枝

1.如果T比图上所有的可走点还要大,肯定是不可行的。这个可以避免dfs整张图。

2.奇偶剪枝,有性质当前点(x,y)到目标点(tx,ty)的所有路径的长度的奇偶性一定和|x-tx|+|y-ty|一样。

#include <cstdio>
#include <iostream>
#include <cstdlib>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <stack>
#include <cstring>
#include <string>

using namespace std;

const int maxn = 15;

char mp[maxn][maxn];
bool vis[maxn][maxn];
int dx[4] = {-1,1,0,0},dy[4] = {0,0,-1,1};
int T,ex,ey;

int abs(int x) {
    if(x < 0) return -x;
    else return x;
}

bool dfs(int x,int y,int t) {
    if(mp[x][y] == ‘D‘ && t == T) return true;
    if(t >= T) return false;
    vis[x][y] = true;
    bool ret = false;
    int dis = abs(x - ex) + abs(y - ey);
    if(dis % 2 != (T - t) % 2) return false;
    for(int d = 0;d < 4;d++) {
        int nx = x + dx[d],ny = y + dy[d];
        if(mp[nx][ny] != ‘X‘ && !vis[nx][ny]) {
            ret |= dfs(nx,ny,t + 1);
        }
        if(ret) return true;
    }
    vis[x][y] = false;
    return false;
}

int main() {
//    freopen("in.txt","r",stdin);
    int n,m,t,sx,sy,cnt_p;
    while(scanf("%d%d%d",&n,&m,&t),n) {
        cnt_p = 0;
        memset(vis,0,sizeof(vis));
        T = t;
        for(int i = 0;i <= n + 1;i++) {
            for(int j = 0;j <= m + 1;j++) {
                mp[i][j] = ‘X‘;
            }
        }
        for(int i = 1;i <= n;i++) {
            for(int j = 1;j <= m;j++) {
                scanf(" %c",&mp[i][j]);
                if(mp[i][j] == ‘S‘) {
                    sx = i; sy = j;
                }
                else if(mp[i][j] == ‘.‘) cnt_p++;
                else if(mp[i][j] == ‘D‘){
                    ex = i; ey = j;
                }
            }
        }
        if(t <= cnt_p + 1&& dfs(sx,sy,0)) {
            puts("YES");
        } else puts("NO");
    }
    return 0;
}

  

HDU 1010 Tempter of the Bone dfs+剪枝,布布扣,bubuko.com

时间: 2024-10-26 10:14:05

HDU 1010 Tempter of the Bone dfs+剪枝的相关文章

HDU 1010 Tempter of the Bone(DFS剪枝)

Tempter of the Bone Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 129289    Accepted Submission(s): 34906 Problem Description The doggie found a bone in an ancient maze, which fascinated him a

HDU 1010 Tempter of the Bone heuristic 剪枝法

本题就是考剪枝法了. 应该说是比较高级的应用了.因为要使用heuristic(经验)剪枝法.要总结出这个经验规律来,不容易.我说这是高级的应用也因为网上太多解题报告都没有分析好这题,给出的程序也很慢,仅仅能过掉,由此看来很多人没有做好这道题. 这里我需要更正一下网上流行的说法:奇偶剪枝法. 其实本题使用奇偶剪枝法并不能太大提高速度,只能说仅仅让使用奇偶剪枝过掉.所以网上说本题使用奇偶剪枝的,其实并不能提高速度. 原因: 奇偶剪枝只能剪枝一次,不能在递归的时候剪枝,因为只要初始化位置符合奇偶性,那

HDU 1010 Tempter of the Bone (DFS 奇偶剪枝)

Tempter of the Bone Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 75141    Accepted Submission(s): 20531 Problem Description The doggie found a bone in an ancient maze, which fascinated him a

hdu.1010.Tempter of the Bone(dfs+奇偶剪枝)

Tempter of the Bone Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 82702    Accepted Submission(s): 22531 Problem Description The doggie found a bone in an ancient maze, which fascinated him a

hdu 1010 Tempter of the Bone DFS+奇偶剪枝,入门题

Tempter of the Bone Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 78390    Accepted Submission(s): 21395 Problem Description The doggie found a bone in an ancient maze, which fascinated him a

hdu - 1010 Tempter of the Bone (dfs+奇偶性剪枝) &amp;&amp; hdu-1015 Safecracker(简单搜索)

http://acm.hdu.edu.cn/showproblem.php?pid=1010 这题就是问能不能在t时刻走到门口,不能用bfs的原因大概是可能不一定是最短路路径吧. 但是这题要过除了细心外,还需要强力的剪枝. 奇偶性剪枝:参考 http://www.cppblog.com/Geek/archive/2010/04/26/113615.html 1 #include <iostream> 2 #include <cstring> 3 #include <cstdi

HDU 1010 Tempter of the Bone DFS 简单题 注意剪枝

题意:一只小狗要刚好在t时刻从起点都到终点,问可不可以. 注意剪枝. 1 #include<cstdio> 2 #include<cstring> 3 #include<cmath> 4 using namespace std; 5 int maze[9][9]; 6 bool vis[9][9]; 7 int n,m,t; 8 bool ans; 9 struct Point 10 { 11 int x,y; 12 }; 13 int dx[4]={0,0,-1,1}

HDU 1010 Tempter of the Bone(DFS)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1010 题目大意: 输入 n m t,生成 n*m 矩阵,矩阵元素由 ‘.’ 'S' 'D' 'X' 四类元素组成. S'代表是开始位置: 'D'表示结束位置:'.'表示可以走的路:'X'表示是墙. 问:从‘S’  能否在第 t 步 正好走到 'D'. 解题思路: 1 #include<bits/stdc++.h> 2 using namespace std; 3 int n,m,t; 4 int

HDU_(1010) Tempter of the Bone(DFS,剪枝)

题目请点我 题意: 有一个迷宫,看能不能经过T秒恰好从起点走到终点.因为可能会考虑到绕路,2^49可能会超时(况且涉及到绕路,墙的数目一定不会很多),我们就可以在每次都进行一次判断,看剩下的时间能否走到终点.另外因为只能在T秒走到,那么绕路的话一定会多走偶数步数,利用这个性质也可以剪枝.这道题其实之前做过的,但是第二次做还是TLE了很多次,其实这题的关键不仅是dfs,在T秒恰好到达需要绕路才是这道题的亮点,trap也在这里. 代码: #include <iostream> #include &